<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- 
IGAC proyecto SNC
@author 		javier.aponte
@version 		1.0
@description	Pantalla que muestra el formulario para adicionar un nuevo producto a la solicitud
@cu 			CU-TV-PR-001
@param			managedBeanParam: 		Nombre del ManagedBean del que se obtendran los parametros
@param			 selectedSolicitudParam: objeto de tipo Solicitud que se está creando o editando

-->

<h:form xmlns="http://www.w3.org/1999/xhtml"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:fn="http://java.sun.com/jsp/jstl/functions"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:p="http://primefaces.org/ui" 
        id="nuevoProductoSolForm">

    <h:inputText id="errortFocus" style="border:0px;height:0;" />

    <p:messages id="msgsProducto" showDetail="false" globalOnly="false" />

    <p:spacer width="0" height="13" />

    <h:panelGrid columns="2" width="100%">
        <h:panelGrid columns="8" width="100%">
            <h:outputLabel value="No. solicitud:" styleClass="outputLabelStyle" />
            <h:panelGrid columns="2">
                <p:commandLink oncomplete="detalleSolicitudWV.show();"
                               update=":detalleSolicitudEjecutarForm">
                    <h:outputText value="#{selectedSolicitudParam.numero}"
                                  styleClass="commandLinkStyle" />
                    <f:setPropertyActionListener
                        value="#{selectedSolicitudParam}"
                        target="#{vistaDetallesSolicitud.solicitudSeleccionada}" />
                </p:commandLink>
                <p:spacer height="0" width="10" />
            </h:panelGrid>

            <p:spacer height="0" width="7"/>
            <h:outputLabel value="Fecha de solicitud:"
                           styleClass="outputLabelStyle"/>
            <h:panelGrid columns="2">
                <h:outputText value="#{selectedSolicitudParam.fecha}"
                              styleClass="outputTextStyle">
                    <f:convertDateTime pattern="#{general.formatoFecha}" locale="es" />
                </h:outputText>
                <p:spacer height="0" width="10" />
            </h:panelGrid>

            <p:spacer height="0" width="7"/>
            <h:outputLabel value="Tipo de solicitud:"
                           styleClass="outputLabelStyle"/>
            <h:panelGrid columns="2">
                <h:outputText value="#{selectedSolicitudParam.tipo}"
                              styleClass="outputTextStyle" id="SolicitudTipoV">
                    <f:converter converterId="converterCB" for="SolicitudTipoV" />
                </h:outputText>
                <p:spacer height="0" width="10" />
            </h:panelGrid>

        </h:panelGrid>
    </h:panelGrid>

    <p:spacer height="30" width="13" />

    <p:fieldset toggleable="true" toggleSpeed="500"
                id="documentosSoportesFS">
        <legend>
            <h:outputText value="Documentos soportes"
                          styleClass="legendTitle" />
        </legend>

        <h:panelGrid columns="6" width="100%" rendered="#{managedBeanParam.activarOpcionesDocumentosSoportes}">
            <h:panelGrid columns="2">
                <h:outputLabel value="Tipo documento soporte: " for="tipoDocumentoSoporte"
                               styleClass="outputLabelStyle" />
                <h:outputLabel value="*" styleClass="requiredLabelStyle" />
            </h:panelGrid>

            <h:panelGrid columns="2">
                <h:selectOneMenu id="tipoDocumentoSoporte" 
                                 required="true" style="position:relative;left:3px;"
                                 requiredMessage="Debe seleccionar el tipo de documento soporte"
                                 value="#{managedBeanParam.tipoDocumentoSoporteSeleccionado.id}" label="Tipo de documento soporte">
                    <f:selectItems value="#{general.tipoDocumentoSoporteProductosV}" />

                </h:selectOneMenu>
            </h:panelGrid>

            <h:panelGrid columns="2">
                <h:outputLabel value="No. soporte: " for="numeroDocumentoSoporte"
                               styleClass="outputLabelStyle" />
                <h:outputLabel value="*" styleClass="requiredLabelStyle" />
            </h:panelGrid>

            <h:inputText value="#{managedBeanParam.nuevoDocumentoSoporte.numeroDocumento}"
                         id="numeroDocumentoSoporte"
                         label="Número de documento soporte" maxlength="50" required="true">
            </h:inputText>


            <h:panelGrid columns="2">
                <h:outputLabel value="Fecha Doc. Soporte: " for="fechaDocumentoSoporte"
                               styleClass="outputLabelStyle" />
                <h:outputLabel value="*" styleClass="requiredLabelStyle" />
            </h:panelGrid>

            <p:calendar id="fechaDocumentoSoporte"
                        value="#{managedBeanParam.nuevoDocumentoSoporte.fechaDocumento}"
                        label="Fecha documento soporte" required="true" effect="explode"
                        navigator="true" locale="es_CO"
                        pattern="#{general.formatoFecha}" showOn="both"
                        maxdate="#{general.fechaActual}"
                        title="#{general.formatoFechaUsuario}" size="10" />

            <p:commandButton value="Adicionar"
                             icon="ui-icon ui-icon-circle-plus"
                             update="msgsProducto, tblDatosDocumentoSoporte, documentosSoportesFS"
                             action="#{managedBeanParam.adicionarDocumentoSoporteProductos}"
                             onstart="statusDialog2.show();"
                             oncomplete="statusDialog2.hide();"
                             process="@form"/>

        </h:panelGrid>

        <h:panelGrid columns="1" width="100%">

            <p:dataTable id="tblDatosDocumentoSoporte" var="documentoSoporte"
                         rowKey="#{docuementoSoporte.id}"
                         emptyMessage="No se han adicionado documentos soporte"
                         value="#{managedBeanParam.documentosSoportesAdicionados}">

                <f:facet name="header">
                    Lista de documentos soportes
                </f:facet>

                <p:column rendered="#{managedBeanParam.activarOpcionesDocumentosSoportes}">
                    <f:facet name="header">
                        Opciones
                    </f:facet>
                    <p:commandButton
                        onstart="statusDialog2.show();"
                        oncomplete="statusDialog2.hide();editarDocumentoSoporteProductoWV.show()"
                        id="editarDocumentoSoporte" icon="ui-icon ui-icon-pencil"
                        update=":editarDocumentoSoporteProductoForm"
                        process="@this"
                        title="Editar">
                        <f:setPropertyActionListener value="#{documentoSoporte}"
                                                     target="#{managedBeanParam.nuevoDocumentoSoporteSeleccionado}" />
                        <f:setPropertyActionListener value="#{documentoSoporte.archivo}"
                                                     target="#{managedBeanParam.rutaMostrar}" />
                    </p:commandButton>
                    <p:commandButton
                        action="#{managedBeanParam.eliminarDocumentoSoporteProductos}"
                        icon="ui-icon ui-icon-trash"
                        title="Eliminar" id="eliminarDocumentacionSoporte"
                        onstart="statusDialog2.show();"
                        oncomplete="statusDialog2.hide();"
                        update=":nuevoProductoSolForm"
                        process="@this">
                        <f:setPropertyActionListener value="#{documentoSoporte}"
                                                     target="#{managedBeanParam.nuevoDocumentoSoporteSeleccionado}" />
                    </p:commandButton>
                </p:column>

                <p:column headerText="Tipo documento soporte">
                    <h:outputText styleClass="outputTextStyle" id="TipoDocumentoSoporteProductosV"
                                  value="#{documentoSoporte.tipoDocumento.id}">
                        <f:converter converterId="converterCB" for="TipoDocumentoSoporteProductosV" />
                    </h:outputText>
                </p:column>

                <p:column headerText="No. soporte">
                    <h:outputText value="#{documentoSoporte.numeroDocumento}" />
                </p:column>

                <p:column headerText="Fecha doc. soporte">
                    <h:outputText value="#{documentoSoporte.fechaDocumento}" >
                        <f:convertDateTime
                            pattern="#{general.formatoFechaComponenteCalendar}" />
                    </h:outputText>
                </p:column>

                <p:column headerText="Documento">

                    <h:outputText value="#{documentoSoporte.archivo}" 
                                  rendered="#{documentoSoporte.archivoADescargar}"/>

                    <p:commandLink
                        value="#{documentoSoporte.archivo}"
                        update=":docViewer:docViewerCCForm" styleClass="commandLinkStyle"
                        oncomplete="docViewerWV.show();statusDialog2.hide()"
                        onstart="statusDialog2.show()" process="@this"
                        action="#{managedBeanParam.cargarDocumentoTemporalProductoPrev}"
                        rendered="#{!documentoSoporte.archivoADescargar}">
                        <f:setPropertyActionListener
                            target="#{previsualizacionDocumento.documentoTemporal}"
                            value="#{documentoSoporte}" />
                    </p:commandLink>
                </p:column>

            </p:dataTable>

            <p:spacer height="15" width="0"/>

            <p:commandButton
                icon="ui-icon-disk"
                value="Aceptar" disabled="#{!managedBeanParam.activarOpcionesDocumentosSoportes}"
                title="Aceptar" id="guardarDocumentacionSoporte"
                action="#{managedBeanParam.validarDocumentosSoportes}"
                immediate="true"
                update="msgsProducto"
                onstart="statusDialog2.show();"
                oncomplete="statusDialog2.hide();handleCompleteSIC(xhr, status,args, guardarDocumentosSoporteWV, true);"/>

        </h:panelGrid>

    </p:fieldset>

    <p:spacer width="0" height="20" />

    <p:fieldset toggleable="true" toggleSpeed="500"
                id="productosAsociadosASolicitudFS" rendered="#{managedBeanParam.activarPanelProductosAsociados}">
        <legend>
            <h:outputText value="Productos asociados a la solicitud"
                          styleClass="legendTitle" />
        </legend>

        <h:panelGrid columns="1" width="100%">

            <p:dataTable id="tblDatosProductosAsociados" var="productoCatastralAsociado"
                         rowKey="#{productoCatastralAsociado.id}"
                         emptyMessage="No se han adicionado productos a la solicitud"
                         value="#{managedBeanParam.productosCatastralesAsociados}">

                <f:facet name="header">
                    Productos asociados a la solicitud
                </f:facet>

                <p:column rendered="#{managedBeanParam.activarOpcionesProductosAsociados}">
                    <f:facet name="header">
                        Opciones
                    </f:facet>
                    <p:commandButton
                        onstart="statusDialog2.show();"
                        oncomplete="statusDialog2.hide(); adicionarProductoWV.show()"
                        id="editarProductoCatastralAsociado" icon="ui-icon ui-icon-pencil"
                        update=":adicionarProductoSolForm"
                        title="Editar">
                        <f:setPropertyActionListener value="#{productoCatastralAsociado}"
                                                     target="#{managedBeanParam.productoCatastralSeleccionado}" />
                        <f:setPropertyActionListener value="#{true}"
                                                     target="#{managedBeanParam.editarProductoCatastral}" />
                    </p:commandButton>
                    <p:commandButton
                        action="#{managedBeanParam.eliminarProductosCatastralesAsociados}"
                        icon="ui-icon ui-icon-trash"
                        title="Eliminar" id="eliminarProductoCatastralAsociado"
                        onstart="statusDialog2.show();"
                        oncomplete="statusDialog2.hide();"
                        update=":nuevoProductoSolForm"
                        process="@this">
                        <f:setPropertyActionListener value="#{productoCatastralAsociado}"
                                                     target="#{managedBeanParam.productoCatastralSeleccionado}" />
                    </p:commandButton>
                </p:column>

                <p:column headerText="Código">
                    <h:outputText value="#{productoCatastralAsociado.producto.codigo}" />
                </p:column>

                <p:column headerText="Descripción">
                    <h:outputText value="#{productoCatastralAsociado.producto.nombre}" />
                </p:column>

                <p:column headerText="Cantidad">
                    <h:outputText value="#{productoCatastralAsociado.cantidad}" />
                </p:column>				

            </p:dataTable>

            <p:spacer height="10" width="0"/>

            <h:panelGrid columns="3">
                <p:commandButton value="Adicionar"
                                 rendered="#{managedBeanParam.activarOpcionesProductosAsociados}"
                                 icon="ui-icon ui-icon-circle-plus"
                                 action="#{managedBeanParam.inicializarProductoCatastralAsociadoASolicitud}"
                                 update="msgsProducto, tblDatosProductosAsociados, :adicionarProductoSolForm"
                                 onstart="statusDialog2.show();" immediate="true"
                                 oncomplete="statusDialog2.hide();adicionarProductoWV.show();"
                                 process="@form">
                    <f:setPropertyActionListener value="#{false}"
                                                 target="#{managedBeanParam.editarProductoCatastral}" />
                </p:commandButton>

                <p:spacer height="0" width="10"/>

                <p:commandButton
                    icon="ui-icon-disk"
                    value="Aceptar"
                    disabled="#{!managedBeanParam.activarOpcionesProductosAsociados}"
                    title="Aceptar" id="guardarProductosCatastrales"
                    action="#{managedBeanParam.validarProductosAsociados}"
                    update="msgsProducto"
                    onstart="statusDialog2.show();"
                    oncomplete="statusDialog2.hide();handleCompleteSIC(xhr, status,args, guardarProductosAsociadosWV, true);"/>
            </h:panelGrid>

        </h:panelGrid>

    </p:fieldset>

    <p:spacer height="10" width="0"/>

    <h:panelGrid >

        <p:commandButton value="Registrar datos de productos"
                         ajax="false" title="Registrar datos de productos"
                         action="#{managedBeanParam.registrarDatosDeProductos}"
                         rendered="#{!managedBeanParam.activarOpcionesProductosAsociados}"
                         icon="ui-icon-seek-next"/>

    </h:panelGrid>

    <p:confirmDialog appendToBody="true"
                     message="¿Está seguro? (una vez que acepte, no podra adicionar, eliminar ni modificar los documentos soporte)"
                     width="400" 
                     header="Confirmación" severity="alert"
                     widgetVar="guardarDocumentosSoporteWV">

        <p:commandButton value="Sí"
                         update=":nuevoProductoSolForm"
                         process="@this"
                         action="#{managedBeanParam.guardarDocumentosSoporteProductos}"
                         icon="ui-icon-check"
                         onstart="statusDialog2.show()"
                         oncomplete="statusDialog2.hide();guardarDocumentosSoporteWV.hide();"/>

        <p:commandButton value="No" icon="ui-icon-close"
                         onclick="guardarDocumentosSoporteWV.hide();"
                         type="button" />
    </p:confirmDialog>

    <p:confirmDialog appendToBody="true"
                     message="¿Está seguro? (una vez que acepte, no podra adicionar, eliminar ni modificar los productos asociados)"
                     width="400" 
                     header="Confirmación" severity="alert"
                     widgetVar="guardarProductosAsociadosWV">

        <p:commandButton value="Sí"
                         update=":nuevoProductoSolForm"
                         process="@this"
                         action="#{managedBeanParam.guardarProductosCatastralesAsociadosASolicitud}"
                         icon="ui-icon-check"
                         onstart="statusDialog2.show()"
                         oncomplete="statusDialog2.hide();guardarProductosAsociadosWV.hide();"/>

        <p:commandButton value="No" icon="ui-icon-close"
                         onclick="guardarProductosAsociadosWV.hide();"
                         type="button" />
    </p:confirmDialog>

</h:form>

